---
# tasks file for zero-app-minio
- name: Provision minio
  block:
    - name: Creating app directory
      file:
        path: "{{ app_dir }}"
        state: directory
        mode: '0755'

    - name: Copy Stack-File
      template:
        src: templates/docker-compose.yml.j2
        dest: "{{ app_dir }}/docker-compose.yml"
        owner: root
        group: root
        mode: '0644'
      register: stack_file

    - name: Create config directories
      file:
        path: "{{ app_dir }}/{{ config_dir.path }}"
        state: directory
        mode: '{{ config_dir.mode }}'
      with_filetree:
        - "files/"
      when: config_dir.state == 'directory'
      loop_control:
        label: "{{ config_dir.path }}"
        loop_var: config_dir

    - name: Copy config files
      copy:
        src: "{{ config_file.src }}"
        dest: "{{ app_dir }}/{{ config_file.path }}"
        mode: "{{ config_file.mode }}"
      with_filetree:
        - "files/"
      when: config_file.state == 'file'
      loop_control:
        label: "{{ config_file.path }}"
        loop_var: config_file

    - name: Pull images
      docker_image:
        name: "{{ item.value }}"
        source: pull
      with_dict: "{{ images }}"

    - name: Provision minio
      docker_stack:
        state: present
        name: minio
        prune: yes
        with_registry_auth: yes
        compose:
          - "{{ app_dir }}/docker-compose.yml"
      register: minio_provision

    - name: "Wait for http://{{ app_domain }} to become ready"
      uri:
        url: "http://{{ app_domain }}/minio/health/live"
        method: GET
        status_code: 200
        validate_certs: no
      register: _result
      until: _result.status == 200
      retries: "{{ app_healthcheck_retries }}"
      delay: "{{ app_healthcheck_delay }}"